/*
 * Copyright 2021 Wultra s.r.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { NativeModules, Platform } from 'react-native';
/**
 * Class representing a multi-factor authentication object.
 */
var PowerAuthAuthentication = /** @class */ (function () {
    function PowerAuthAuthentication() {
        /** Indicates if a possession factor should be used. */
        this.usePossession = false;
        /** Indicates if a biometry factor should be used. */
        this.useBiometry = false;
        /** Password to be used for knowledge factor, or nil of knowledge factor should not be used */
        this.userPassword = null;
        /**
         * Message displayed when prompted for biometric authentication
         */
        this.biometryMessage = null;
        /** (Android only) Title of biometric prompt */
        this.biometryTitle = null;
        /** Filled by the SDK. */
        this.biometryKey = null;
    }
    PowerAuthAuthentication.prototype.process = function () {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var key;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!(Platform.OS == "android" && this.useBiometry)) return [3 /*break*/, 2];
                        return [4 /*yield*/, NativeModules.PowerAuth.authenticateWithBiometry((_a = this.biometryTitle) !== null && _a !== void 0 ? _a : "??", (_b = this.biometryMessage) !== null && _b !== void 0 ? _b : "??")];
                    case 1:
                        key = _c.sent();
                        this.biometryKey = key;
                        _c.label = 2;
                    case 2: return [2 /*return*/, this];
                }
            });
        });
    };
    return PowerAuthAuthentication;
}());
export { PowerAuthAuthentication };
;
